<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "{{%rol}}".
 *
 * @property integer $idrol
 * @property string $nombrerol
 *
 * @property Permiso[] $permisos
 */
class Rol extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return '{{%rol}}';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['nombrerol'], 'string', 'max' => 45]
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'idrol' => Yii::t('app', 'Idrol'),
            'nombrerol' => Yii::t('app', 'Nombrerol'),
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getPermisos()
    {
        return $this->hasMany(Permiso::className(), ['idrol' => 'idrol']);
    }

    /**
     * @inheritdoc
     * @return RolQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new RolQuery(get_called_class());
    }
}
